

#include "HUDDialogue.h"

#include "core/XMLPort.h"

#include <OgreCamera.h>
#include <OgreFontManager.h>
#include <OgreOverlayManager.h>
#include <OgreTextAreaOverlayElement.h>
#include <OgrePanelOverlayElement.h>
#include "core/CoreIncludes.h"

namespace orxonox
{

	 RegisterClass (HUDDialogue);

	 HUDDialogue::HUDDialogue(Context* context) :
        OrxonoxOverlay(context)
    {
        RegisterObject(HUDDialogue);
	}     
    void HUDDialogue::updateTarget(std::string portrait)
    {
    	overlayElementIcon_ = static_cast<Ogre::PanelOverlayElement* >(Ogre::OverlayManager::getSingleton().createOverlayElement("Panel", "Dialogue" + getUniqueNumberString()));
        overlayElementIcon_->setPosition(0.0f,0.0f);
        overlayElementIcon_->setDimensions(1.0f,1.0f);
        this->background_->addChild(overlayElementIcon_);     

    	overlayElementIcon_->setMaterialName(portrait);
    	this->setVisible(true);
    	portraitTimer.setTimer(2.9f,false,createExecutor(createFunctor(&HUDDialogue::invisible, this)));
    }
    void HUDDialogue::invisible()
    {
    	this->setVisible(false);
    	Ogre::OverlayManager::getSingleton().destroyOverlayElement(this->overlayElementIcon_);
    }
	 HUDDialogue::~HUDDialogue()
	 {


	 }
}